package cn.iocoder.yudao.module.supplier.service.product;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.supplier.controller.admin.product.vo.ProductPageReqVO;
import cn.iocoder.yudao.module.supplier.controller.admin.product.vo.ProductSaveReqVO;
import cn.iocoder.yudao.module.supplier.dal.dataobject.product.ProductDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 供应商产品 Service 接口
 *
 * @author 芋道源码
 */
public interface ProductService {

    /**
     * 创建供应商产品
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createProduct(@Valid ProductSaveReqVO createReqVO);

    /**
     * 更新供应商产品
     *
     * @param updateReqVO 更新信息
     */
    void updateProduct(@Valid ProductSaveReqVO updateReqVO);

    /**
     * 删除供应商产品
     *
     * @param id 编号
     */
    void deleteProduct(Long id);

    /**
     * 获得供应商产品
     *
     * @param id 编号
     * @return 供应商产品
     */
    ProductDO getProduct(Long id);

    /**
     * 获得供应商产品分页
     *
     * @param pageReqVO 分页查询
     * @return 供应商产品分页
     */
    PageResult<ProductDO> getProductPage(ProductPageReqVO pageReqVO);

    List<ProductDO> getAll();
}
